### Virtual Method

# GUPnP Acl is_allowed_async

since: 0.20.11

#### Declaration [src]

    void
    is_allowed_async (
      GUPnPAcl* self,
      GUPnPDevice* device,
      GUPnPService* service,
      const char* path,
      const char* address,
      const char* agent,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer user_data
    )

#### Description [src]

Check asynchronously whether an IP address is allowed to access this resource.

This function is optional. `gupnp_acl_can_sync()` should return `TRUE` if the implementing class supports it. If it is supported, GUPnP will prefer to use this function over `gupnp_acl_is_allowed()`.

Implement this function if the process of verifying the access right is expected to take some time, for example when using D-Bus etc.

Use `gupnp_acl_is_allowed_finish()` to retrieve the result.

Available since: 0.20.11

#### Parameters

`device`

  Type: `GUPnPDevice`

  The `GUPnPDevice` associated with `path` or `NULL` if unknown.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`service`

  Type: `GUPnPService`

  The `GUPnPService` associated with `path` or `NULL` if unknown.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`path`

  Type: `const char*`

  The path being served.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`address`

  Type: `const char*`

  IP address of the peer.

  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`agent`

  Type: `const char*`

  The User-Agent header of the peer or `NULL` if not unknown.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  A cancellable which can be used to cancel the operation.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`callback`

  Type: `GAsyncReadyCallback`

  Callback to call after the function is done.

`user_data`

  Type: `gpointer`

  Some user data.

  The argument can be `NULL`.
  The data is owned by the caller of the method.